#!/usr/bin/python
#
# (c) 2019 Check Point Software Technologies
#
# Loger for ansible task
#
# VER   DATE            WHO                     WHAT
#------------------------------------------------------------------------------
# v1.0 -               Yevgeniy Yeryomin       Creation of the script


import sys
import datetime
import time
import os
import re
import math

#import strftime

# ToDo get it from the central config file
print(os.getcwd())
logFile="logs/gaant_logs.log"

print("From create log script.")
print("Following log file is configured:"+logFile)
print("Provided arguments:"+str(sys.argv))

BLANK="__blank"
OK_MESSAGE="OK"
FAILED_MESSAGE="FAILED"



def writeLogLine(_logLine):
    if os.path.exists(logFile): #optional check if file exists
        #print("File exists")
        f = open(logFile, "a")
        f.write(_logLine+"\n")
        f.close()
    else:
        #print("File doesn't exist")
        f = open(logFile, "w")
        f.write(_logLine+"\n")
        f.close()

### Tasks hanlders
def getLoginStatus():

    if logDict["result"]==FAILED_MESSAGE:
        # get responseMessage
        logDict["responseMessage"]=getValueForKey(sys.argv, "msg:")
        logDict["responseMessage"]=logDict["responseMessage"][1:]



def getAddUserClishResponse():
    logDict["responseMessage"]=""
    # look for responseCode
    i=0

    logDict["responseCode"]=getValueForKey(sys.argv, "code:")
    logDict["responseMessage"]=getValueForKey(sys.argv, "message:")
    print("Clish code: "+logDict["responseCode"])
    print("Clish message: "+logDict["responseMessage"])


    #logDict["responseCode"]=logDict["responseCode"].replace("u", "")
    logDict["responseCode"]=logDict["responseCode"].replace("}", "")
    logDict["responseCode"]=logDict["responseCode"][1:]

    buff=logDict["responseMessage"].split("\\n")
    for b in buff:
        print("b="+b)
    if  len(buff)>1:
        logDict["responseMessage"]=buff[0]
    logDict["responseMessage"]=logDict["responseMessage"][1:]
    logDict["responseMessage"]=logDict["responseMessage"].replace("OK,", "OK")


    print("Clish code: "+logDict["responseCode"])
    print("Clish message: "+logDict["responseMessage"])



def getValueForKey(_list, _key):
    value=""
    i=0
    for item in _list:
        if str(item).lower().endswith(_key.lower()):
            if len(_list)>=i:
                value=str(_list[i+1])
            break
        i=i+1

    return value

def fillLogDict_forGaiaAPI_Playbook():

    # Check failed status
    value=getValueForKey(sys.argv,  "failed:")
    print("value:"+value)
    if str(value).lower().startswith("false"):
        logDict["result"]=OK_MESSAGE
    else:
        logDict["result"]=FAILED_MESSAGE

    # Check sid value
    sid=getValueForKey(sys.argv, "sid:")
    print("sid:"+sid)
    if sid=="":
        logDict["result"]=FAILED_MESSAGE
    elif sid.lower().startswith("none"):
        logDict["result"]=FAILED_MESSAGE
    else:
        logDict["result"]=OK_MESSAGE



    if str(value).lower().startswith("false") and sid=="" and logDict["action"].lower()=="config-mgmt-int":
        logDict["result"]=OK_MESSAGE

    if str(value).lower().startswith("false") and sid=="" and logDict["action"].lower()=="load_clish_config":
        logDict["result"]=OK_MESSAGE

    if str(value).lower().startswith("false") and sid=="" and logDict["action"].lower()=="copy_clish_config":
        logDict["result"]=OK_MESSAGE

    if str(value).lower().startswith("false") and sid=="" and logDict["action"].lower()=="copy_clish_config":
        logDict["result"]=OK_MESSAGE



    ### Handlers for specific GAiA API tasks
    if logDict["action"].lower()=="login":
        getLoginStatus()
    elif logDict["action"].lower()=="add-user" or logDict["action"].lower()=="set-user":
        getAddUserClishResponse()
    elif logDict["action"].lower()=="delete-user":
        getAddUserClishResponse()

    ### Adjust result flags
    # if logDict["failed"]=="False":
    #     logDict["result"]=OK_MESSAGE
    # else:
    #     logDict["result"]="FAILED"
    #
    # if logDict["unchanged"]=="False":
    #     logDict["changed"]="Changed"
    # else:
    #     logDict["changed"]="Unchanged"


def fillLogDict_forMgmtAPI_Playbook():
    value=getValueForKey(sys.argv,  "failed:")
    print("value:"+value)
    if str(value).lower().startswith("false"):
        logDict["result"]=OK_MESSAGE
    else:
        logDict["result"]=FAILED_MESSAGE

    logDict["responseMessage"]=getValueForKey(sys.argv, "mgmtResponse:")


def fillLogDict_forShellCommands_Playbook():
    print("From fillLogDict_forShellCommands_Playbook")

    i=0
    for arg in sys.argv:
        if i==8:
            logDict["result"]=arg
        elif i==9:
            logDict["responseCode"]="clish_command_failed"
            logDict["responseMessage"]=str(arg).strip()
        i=i+1


def reduceNumberToFixedLenght(_number):
    result=""
    if _number>10:
        diff=len(str(_number))-10
        divider=math.pow(10,diff)
        result=int(int(_number)/divider)
        result=str(result)
    return result


### MAIN

# Get time
# Get unixtimestamp
#time=datetime.now().strftime('%Y-%m-%d %H:%M:%S')
curTime=str(datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'))
print("Time: "+curTime)

unixtimestamp=str(int(time.time()*100))
print("Time: "+unixtimestamp)

# following arguments are expected
# sourceFile runID cma gName gwIP taskName taskValue failedValue uid responseCode responseMessage
#'fromGaiaAPI_Playbook' '123123', 'First_Domain', 'RemoteOffice3', '192.168.168.121', '{failed:', 'False,', 'uchanged:', 'False,', 'uresponse:', '{uurl:', 'u192.168.168.121:443,', 'udomain:', 'None,', 'usid:', 'u5412813922920336162,', 'ufingerprint:', 'u98B4B5D7BFE7313DFDE1878B9C238993DCE9F32C}}', 'set ntp secondary 10.0.0.3']

logDict={}
logDict["sourcePlaybook"]=""
logDict["runID"]=""
logDict["mode"]="" #GAiA_API, MGMT_API; ExpertMode
logDict["cmaName"]=""
logDict["gwName"]=""
logDict["gwIP"]=""
logDict["action"]=""
logDict["value"]=""
logDict["failed"]=""
logDict["unchanged"]=""
logDict["responseCode"]=""
logDict["responseMessage"]=""
logDict["result"]=""

print("List of arguments:")
i=0
for arg in sys.argv:
    print("arg:"+str(i)+":"+str(arg))
    i=i+1

# Check from which playbook we got the request
i=0
for arg in sys.argv:
    if i==1:
        logDict["sourcePlaybook"]=arg
        break
    i=i+1

i=0
for arg in sys.argv:
    if i==2:
        logDict["runID"]=arg
    elif i==3:
        logDict["cmaName"]=arg
    elif i==4:
        logDict["gwName"]=arg
        if logDict["gwName"]==BLANK:
            logDict["gwName"]=""
    elif i==5:
        logDict["gwIP"]=arg
        if logDict["gwIP"]==BLANK:
            logDict["gwIP"]=""
    elif i==6:
        logDict["action"]=arg
    elif i==7:
        logDict["value"]=arg
    i=i+1


print("sourcePlaybook:"+logDict["sourcePlaybook"])
if logDict["sourcePlaybook"]=="fromGaiaAPI_Playbook":
    print("fromGaiaAPI_Playbook")
    fillLogDict_forGaiaAPI_Playbook()
    logDict["mode"]="GAiA_API"
elif logDict["sourcePlaybook"]=="fromMgmtAPI_Playbook":
    print("fromMgmtAPI_Playbook")
    fillLogDict_forMgmtAPI_Playbook()
    logDict["mode"]="MGMT_API"
elif logDict["sourcePlaybook"]=="fromShellCommands_Playbook":
    print("fromShellCommands_Playbook")
    fillLogDict_forShellCommands_Playbook()
    logDict["mode"]="ExpertMode"
else:
    print("The sourcePlaybook is unknown.")
    print("We stop here.")
    exit()


# Correc the runID if nessesary
logDict["runID"]=reduceNumberToFixedLenght(logDict["runID"])
print("runID: "+logDict["runID"])

print("Data for the log file: ")
print(logDict)

### Prepare logLIne
logLine=(
curTime+";"+
#unixtimestamp+";"+
logDict["runID"]+";"+
logDict["mode"]+";"+
logDict["cmaName"]+";"+
logDict["gwName"]+";"+
logDict["gwIP"]+";"+
logDict["action"]+";"+
logDict["value"]+";"+
logDict["result"]+";"+
#logDict["changed"]
logDict["responseCode"]+";"+
logDict["responseMessage"]
)

# Write line into the log file
print("logLine: "+logLine)
writeLogLine(logLine)
