#!/usr/bin/python
import sys
import datetime
import time
import os
import re
import math

#import strftime

# ToDo get it from the central config file
print(os.getcwd())
logFile="logs/gaant_logs.log"

print("From create log script.")
print("Following log file is configured:"+logFile)
print("Provided arguments:"+str(sys.argv))

FAILED_MESSAGE="FAILED"


def writeLogLine(_logLine):
    if os.path.exists(logFile): #optional check if file exists
        #print("File exists")
        f = open(logFile, "a")
        f.write(_logLine+"\n")
        f.close()
    else:
        #print("File doesn't exist")
        f = open(logFile, "w")
        f.write(_logLine+"\n")
        f.close()

### Tasks hanlders
def getLoginStatus():

    if logDict["result"]==FAILED_MESSAGE:
        # get responseMessage
        logDict["responseMessage"]=getValueForKey(sys.argv, "msg:")
        logDict["responseMessage"]=logDict["responseMessage"][1:]



def getAddUserClishResponse():
    logDict["responseMessage"]=""
    # look for responseCode
    i=0

    logDict["responseCode"]=getValueForKey(sys.argv, "code:")
    logDict["responseMessage"]=getValueForKey(sys.argv, "message:")
    print("Clish code: "+logDict["responseCode"])
    print("Clish message: "+logDict["responseMessage"])


    #logDict["responseCode"]=logDict["responseCode"].replace("u", "")
    logDict["responseCode"]=logDict["responseCode"].replace("}", "")
    logDict["responseCode"]=logDict["responseCode"][1:]

    buff=logDict["responseMessage"].split("\\n")
    for b in buff:
        print("b="+b)
    if  len(buff)>1:
        logDict["responseMessage"]=buff[0]
    logDict["responseMessage"]=logDict["responseMessage"][1:]
    logDict["responseMessage"]=logDict["responseMessage"].replace("OK,", "OK")


    print("Clish code: "+logDict["responseCode"])
    print("Clish message: "+logDict["responseMessage"])



def getValueForKey(_list, _key):
    value=""
    i=0
    for item in _list:
        if str(item).lower().endswith(_key.lower()):
            if len(_list)>=i:
                value=str(_list[i+1])
            break
        i=i+1

    return value

def fillLogDict_forGaiaAPI_Playbook():

    # Check sid value
    if logDict["sid"]=="":
        logDict["result"]=FAILED_MESSAGE
    elif logDict["result"].lower()=="true":
        logDict["result"]=FAILED_MESSAGE
    elif logDict["sid"].lower().startswith("none"):
        logDict["result"]=FAILED_MESSAGE
    else:
        logDict["result"]="OK"

    ### Handlers for specific GAiA API tasks
    # if logDict["action"].lower()=="login":
    #     print("login")
    #     getLoginStatus()
    # elif logDict["action"].lower()=="add-user" or logDict["action"].lower()=="set-user":
    #     getAddUserClishResponse()
    # elif logDict["action"].lower()=="delete-user":
    #     getAddUserClishResponse()


def fillLogDict_forShellCommands_Playbook():
    print("From fillLogDict_forShellCommands_Playbook")

    i=0
    for arg in sys.argv:
        if i==8:
            logDict["result"]=arg
        elif i==9:
            logDict["responseCode"]="clish_command_failed"
            logDict["responseMessage"]=str(arg).strip()
        i=i+1


def reduceNumberToFixedLenght(_number):
    result=""
    if _number>10:
        diff=len(str(_number))-10
        divider=math.pow(10,diff)
        result=int(int(_number)/divider)
        result=str(result)
    return result


### MAIN

# Get time
# Get unixtimestamp
#time=datetime.now().strftime('%Y-%m-%d %H:%M:%S')
curTime=str(datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'))
print("Time: "+curTime)

unixtimestamp=str(int(time.time()*100))
print("Time: "+unixtimestamp)

# following arguments are expected
# sourceFile runID cma gName gwIP taskName taskValue failedValue uid responseCode responseMessage
#'fromGaiaAPI_Playbook' '123123', 'First_Domain', 'RemoteOffice3', '192.168.168.121', '{failed:', 'False,', 'uchanged:', 'False,', 'uresponse:', '{uurl:', 'u192.168.168.121:443,', 'udomain:', 'None,', 'usid:', 'u5412813922920336162,', 'ufingerprint:', 'u98B4B5D7BFE7313DFDE1878B9C238993DCE9F32C}}', 'set ntp secondary 10.0.0.3']

logDict={}
logDict["sourcePlaybook"]=""
logDict["runID"]=""
logDict["cmaName"]=""
logDict["gwName"]=""
logDict["gwIP"]=""
logDict["action"]=""
logDict["value"]=""
logDict["failed"]=""
logDict["unchanged"]=""
logDict["responseCode"]=""
logDict["responseMessage"]=""
logDict["result"]=""

print("List of arguments:")
i=0
for arg in sys.argv:
    print("arg:"+str(i)+":"+str(arg))
    i=i+1

#exit()

# we have following fixed positions for each argument
# sourceFile runID cma gName gwIP {{ loginResp.failed }} {{ loginResp.sid }} taskName taskValue {{ taskResp.code }} {{ taskResp.message }}




i=0
for arg in sys.argv:
    if i==1:
        logDict["sourcePlaybook"]=arg
    if i==2:
        logDict["runID"]=arg
    elif i==3:
        logDict["cmaName"]=arg
    elif i==4:
        logDict["gwName"]=arg
    elif i==5:
        logDict["gwIP"]=arg
    elif i==6:
        logDict["failed"]=arg
    elif i==7:
        logDict["sid"]=arg
    elif i==8:
        logDict["action"]=arg
    elif i==9:
        logDict["value"]=arg
    i=i+1


if logDict["sourcePlaybook"]=="fromGaiaAPI_Playbook":
    print("fromGaiaAPI_Playbook")
    fillLogDict_forGaiaAPI_Playbook()
elif logDict["sourcePlaybook"]=="fromShellCommands_Playbook":
    print("fromShellCommands_Playbook")
    fillLogDict_forShellCommands_Playbook()
else:
    print("The sourcePlaybook is unknown.")
    print("We stop here.")
    exit()


# Correc the runID if nessesary
logDict["runID"]=reduceNumberToFixedLenght(logDict["runID"])
print("runID: "+logDict["runID"])

print("Data for the log file: ")
print(logDict)

### Prepare logLIne
logLine=(
curTime+";"+
#unixtimestamp+";"+
logDict["runID"]+";"+
logDict["cmaName"]+";"+
logDict["gwName"]+";"+
logDict["gwIP"]+";"+
logDict["action"]+";"+
logDict["value"]+";"+
logDict["result"]+";"+
#logDict["changed"]
logDict["responseCode"]+";"+
logDict["responseMessage"]
)

# Write line into the log file
print("logLine: "+logLine)
writeLogLine(logLine)
