#!/usr/bin/python

import getpass
import sys, os
import json
import argparse
import csv
import Helper
import DNSConfigSet


#sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), '/home/yevgeniy/ansible/GatewaysManagementAutomated/scripts/')))
#dnsConfigFile="/home/yevgeniy/ansible/GatewaysManagementAutomated/configs/dns.conf"

def getGwDNSConfList(_gwObjsList, _ansibleDNSInventory, _dnsConfigFile):

    dnsConfigList=[]
    gwDNSConfSetObjsList=[]
    gwDNSConfSetObjsResultList=[]

    dnsConfigList=getDNSConfigList(_dnsConfigFile)
    print("---")
    print("DNS config objects:")
    printDNSConfigList(dnsConfigList)

    # Create the DNS config set for each gw object
    for gwObj in _gwObjsList:
        gwDNSConfSetObj=DNSConfigSet.DNSConfigSet()
        gwDNSConfSetObj.takeDataFromGwObj(gwObj)
        gwDNSConfSetObjsList.append(gwDNSConfSetObj)

    # Get DNS configuration for each gateway
    print("---")
    print("Gw DNS objects:")

    # Get DNS config for all gateways
    gwDNSConfSetObjsResultList=Helper.getSpecificObjectsResultList(gwDNSConfSetObjsList, dnsConfigList)

    # Print result list
    print("---")
    print("Result DNS config for all gateways:")
    for item in gwDNSConfSetObjsResultList:
        print(item.toStr())

    # Create Ansible inventory file
    f = open(_ansibleDNSInventory, "w")
    #header = "---\n# Vars file\n# List of Check Point gateways\ngateways:\n"
    header = "---\n#THIS FILE WAS CREATED BY INVENTORY SCRIPT\n#ALL MANUAL CHANGES WILL BE OVERWRITTEN\n# Vars file\n# List of Check Point gateways\ngateways:\n"
    f.write(header)
    print("---")
    print("Ansible config:")
    for gwDNSObj in gwDNSConfSetObjsResultList:
        print("gwDNSObj: "+ gwDNSObj.toJSON())
        f.write(gwDNSObj.toJSON()+"\n")
    #f.close()

def printDNSConfigList(_dnsConfigList):
    #print("Print list of DNS config objects:")
    i=0
    for item in _dnsConfigList:
        i=i+1
        if i==1:
            print(item.toStrHeader())
            print(item.toStr())
        else:
            print(item.toStr())


def getDNSConfigList(_dnsConfigFile):

    print("Start of get DNS data")
    #configFile="/home/yevgeniy/ansible/GatewaysManagementAutomated/configs/dns.conf"
    print("dnsConfigFile: "+_dnsConfigFile)

    dnsConfigList=[]

    # Get data from dns.conf
    with open(_dnsConfigFile, "r") as ins:
        for line in ins:
            line=line.strip()
            if line.startswith("#"):
                continue
            elif line.startswith("false"):
                            continue
            elif not line: # this is an empty check
                continue

            #print("line:"+line)
            dsnEntryObj=DNSConfigSet.DNSConfigSet()
            dsnEntryObj.fillObjFromCSVStr(line)
            dnsConfigList.append(dsnEntryObj)

    # Check for conflicts

    # For each gateway set the dns values, put in a new list of strings

    # Save the result list into the vars/gateways-dbs.yml

    return dnsConfigList

def main():
    dnsConfigList=[]
    dnsConfigList=getDNSConfigList()

if __name__ == "__main__":
    main()
