#!/usr/bin/python

import getpass
import sys, os
import json
import argparse
import csv
import Helper
import NTPConfigSet

#sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), '/home/yevgeniy/ansible/GatewaysManagementAutomated/scripts/')))

def getGwNTPConfList(_gwObjsList, _ansibleNTPInventory, _ntpConfigFile):
    
    ntpConfigList=[]
    gwNTPConfSetObjsList=[]
    gwNTPConfSetObjsResultList=[]

    ntpConfigList=getNTPConfigList(_ntpConfigFile)
    print("---")
    print("NTP config objects:")
    printNTPConfigList(ntpConfigList)

    # Create the NTP config set for each gw object
    for gwObj in _gwObjsList:
        gwNTPConfSetObj=NTPConfigSet.NTPConfigSet()
        gwNTPConfSetObj.takeDataFromGwObj(gwObj)
        gwNTPConfSetObjsList.append(gwNTPConfSetObj)

    # Get NTP configuration for each gateway
    print("---")
    print("Gw NTP objects:")

    # Get NTP config for all gateways
    gwNTPConfSetObjsResultList=Helper.getSpecificObjectsResultList(gwNTPConfSetObjsList, ntpConfigList)

    # Print result list
    print("---")
    print("Result NTP config for all gateways:")
    for item in gwNTPConfSetObjsResultList:
        print(item.toStr())

    # Create Ansible inventory file
    f = open(_ansibleNTPInventory, "w")
    #header = "---\n# Vars file\n# List of Check Point gateways\ngateways:\n"
    header = "---\n#THIS FILE WAS CREATED BY INVENTORY SCRIPT\n#ALL MANUAL CHANGES WILL BE OVERWRITTEN\n# Vars file\n# List of Check Point gateways\ngateways:\n"
    f.write(header)
    print("---")
    print("Ansible config:")
    for gwNTPObj in gwNTPConfSetObjsResultList:
        print("gwNTPObj: "+ gwNTPObj.toJSON())
        f.write(gwNTPObj.toJSON()+"\n")


def printNTPConfigList(_ntpConfigList):
    #print("Print list of NTP config objects:")
    print("\nNTP config list:")
    i=0
    for item in _ntpConfigList:
        i=i+1
        if i==1:
            print(item.toStrHeader())
            print(item.toStr())
        else:
            print(item.toStr())


def getNTPConfigList(_ntpConfigFile):

    print("Start of get NTP data")

    ntpConfigList=[]
    # Get data from ntp.conf
    with open(_ntpConfigFile, "r") as ins:
        for line in ins:
            line=line.strip()
            if line.startswith("#"):
                continue
            if line.startswith("false"):
                continue
            if not line: # this is an empty check
                continue

            print("line:"+line)
            dsnEntryObj=NTPConfigSet.NTPConfigSet()
            dsnEntryObj.fillObjFromCSVStr(line)
            ntpConfigList.append(dsnEntryObj)

            printNTPConfigList(ntpConfigList)

    return ntpConfigList

def main():
    ntpConfigList=[]
    ntpConfigList=getNTPConfigList()

if __name__ == "__main__":
    main()
