#!/usr/bin/python

import getpass
import sys, os
import json
import argparse
import csv
import Helper
import UserGroupConfigSet

#sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), '/home/yevgeniy/ansible/GatewaysManagementAutomated/scripts/')))

def getGwUserGroupConfList(_gwObjsList, _ansibleUserGroupInventory, _ansibleUserGroupCopyKeysInventory, _userGroupConfigFile, _ansibleHostsConfig):

    userGroupConfigList=[]
    gwUserGroupConfSetObjsList=[]
    gwUserGroupConfSetObjsResultList=[]

    userGroupConfigList=getUserGroupConfigList(_userGroupConfigFile)
    print("---")
    print("UserGroup config objects:")
    printUserGroupConfigList(userGroupConfigList)

    # Create the UserGroup config set for each gw object
    for gwObj in _gwObjsList:
        gwUserGroupConfSetObj=UserGroupConfigSet.UserGroupConfigSet()
        gwUserGroupConfSetObj.takeDataFromGwObj(gwObj)
        gwUserGroupConfSetObjsList.append(gwUserGroupConfSetObj)

    # Get UserGroup configuration for each gateway
    print("---")
    print("Gw UserGroup objects:")

    # Get UserGroup config for all gateways
    gwUserGroupConfSetObjsResultList=Helper.getSpecificObjectsResultList(gwUserGroupConfSetObjsList, userGroupConfigList)

    # Print result list
    print("---")
    print("Result UserGroup config for all gateways:")
    for item in gwUserGroupConfSetObjsResultList:
        print(item.toStr())

    # Create Ansible inventory file for the roles add-user, delete-user
    f = open(_ansibleUserGroupInventory, "w")
    header = "---\n#THIS FILE WAS CREATED BY INVENTORY SCRIPT\n#ALL MANUAL CHANGES WILL BE OVERWRITTEN\n# Vars file\n# List of Check Point gateways\ngateways:\n"
    f.write(header)
    print("---")
    print("Ansible config:")
    for gwUserGroupObj in gwUserGroupConfSetObjsResultList:
        print("gwUserGroupObj: "+ gwUserGroupObj.toJSON())
        f.write(gwUserGroupObj.toJSON()+"\n")

    # Create Ansible inventory file for keys copy
    #_ansibleUserGroupCopyKeysInventory
    f = open(_ansibleUserGroupCopyKeysInventory, "w")
    header = "---\n#THIS FILE WAS CREATED BY INVENTORY SCRIPT\n#ALL MANUAL CHANGES WILL BE OVERWRITTEN\n#Ansible hosts for users keys copy:\n"
    f.write(header)
    print("---")
    print("Ansible host for copyKeys config:")
    # Write the gateways section here
    f.write("\n")
    sectionName="[Gateways]"
    f.write(sectionName+"\n")
    for gwUserGroupObj in gwUserGroupConfSetObjsResultList:
        gwLine=(
        gwUserGroupObj.gw_ip+
        " cma="+gwUserGroupObj.gw_cma+
        " gwName="+gwUserGroupObj.gw_name+
        " gwIP="+gwUserGroupObj.gw_ip+
        " userGroupName="+gwUserGroupObj.userGroupName
        )
        print("gwLine: "+ gwLine)
        f.write(gwLine+"\n")
    # Group vars section
    groupVarsSection=(
    "\n"
    "[Gateways:vars]\n"
    "ansible_connection=ssh\n"
    #"ansible_user="+_ansibleHostsConfig["mgmt_user"]+"\n"
    #"ansible_ssh_pass="+_ansibleHostsConfig["mgmt_password"]+"\n"
    "ansible_user="+_ansibleHostsConfig["ansible_user"]+"\n"
    "ansible_ssh_pass="+_ansibleHostsConfig["ansible_ssh_pass"]+"\n"
    "ansible_python_interpreter=/opt/CPsuite-R80/fw1/Python/bin/python"+"\n"
    "local_key_path="+_ansibleHostsConfig["local_key_path"]+"\n"
    "remote_key_path="+_ansibleHostsConfig["remote_key_path"]+"\n"
    "remote_key_fileName="+_ansibleHostsConfig["remote_key_fileName"]
    )


    f.write(groupVarsSection)

def printUserGroupConfigList(_userGroupConfigList):
    #print("Print list of UserGroup config objects:")
    print("\nUserGroup config list:")
    i=0
    for item in _userGroupConfigList:
        i=i+1
        if i==1:
            print(item.toStrHeader())
            print(item.toStr())
        else:
            print(item.toStr())


def getUserGroupConfigList(_userGroupConfigFile):

    print("Start of get UserGroup data")

    userGroupConfigList=[]
    # Get data from userGroup.conf
    with open(_userGroupConfigFile, "r") as ins:
        for line in ins:
            line=line.strip()
            if line.startswith("#"):
                continue
            if line.startswith("false"):
                continue
            if not line: # this is an empty check
                continue

            print("line:"+line)
            dsnEntryObj=UserGroupConfigSet.UserGroupConfigSet()
            dsnEntryObj.fillObjFromCSVStr(line)
            userGroupConfigList.append(dsnEntryObj)

            printUserGroupConfigList(userGroupConfigList)

    return userGroupConfigList

def main():
    userGroupConfigList=[]
    userGroupConfigList=getUserGroupConfigList()

if __name__ == "__main__":
    main()
